## org.apache.commons.math.ode.nonstiff
Class EulerStepInterpolator

    java.lang.Object
      org.apache.commons.math.ode.sampling.AbstractStepInterpolator
          org.apache.commons.math.ode.nonstiff.RungeKuttaStepInterpolator
              org.apache.commons.math.ode.nonstiff.EulerStepInterpolator

All Implemented Interfaces:
  Externalizable, Serializable, StepInterpolator

     class EulerStepInterpolator

extends RungeKuttaStepInterpolator

This class implements a linear interpolator for step.

This interpolator computes dense output inside the last step computed. The interpolation equation is consistent with the integration scheme :

       y(t_n + theta h) = y (t_n + h) - (1-theta) h y'

where theta belongs to [0 ; 1] and where y' is the evaluation of the derivatives already computed during the step.

Since:
  1.2
Version:
  $Revision: 1073158 $ $Date: 2011-02-21 22:46:52 +0100 (lun. 21 févr. 2011) $
See Also:
  `EulerIntegrator`

Field Summary
`private static long` `serialVersionUID` Serializable version identifier

Fields inherited from class org.apache.commons.math.ode.nonstiff.RungeKuttaStepInterpolator
`integrator, yDotK`

Fields inherited from class org.apache.commons.math.ode.sampling.AbstractStepInterpolator
`currentState, h, interpolatedDerivatives, interpolatedState, interpolatedTime`

Constructor Summary
`EulerStepInterpolator()` Simple constructor.
`EulerStepInterpolator(EulerStepInterpolator interpolator)` Copy constructor.

Method Summary
`protected void` `computeInterpolatedStateAndDerivatives(double theta, double oneMinusThetaH)` Compute the state and derivatives at the interpolated time.
`protected StepInterpolator` `doCopy()` Really copy the finalized instance.

Methods inherited from class org.apache.commons.math.ode.nonstiff.RungeKuttaStepInterpolator
`readExternal, reinitialize, writeExternal`

Methods inherited from class org.apache.commons.math.ode.sampling.AbstractStepInterpolator
`copy, doFinalize, finalizeStep, getCurrentTime, getGlobalCurrentTime, getGlobalPreviousTime, getInterpolatedDerivatives, getInterpolatedState, getInterpolatedTime, getPreviousTime, isForward, readBaseExternal, reinitialize, setInterpolatedTime, setSoftCurrentTime, setSoftPreviousTime, shift, storeTime, writeBaseExternal`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### serialVersionUID

    private static final long serialVersionUID

  Serializable version identifier

  See Also:
    Constant Field Values

Constructor Detail

### EulerStepInterpolator

    public EulerStepInterpolator()

  Simple constructor. This constructor builds an instance that is not usable yet, the `AbstractStepInterpolator.reinitialize(double[], boolean)` method should be called before using the instance in order to initialize the internal arrays. This constructor is used only in order to delay the initialization in some cases. The `RungeKuttaIntegrator` class uses the prototyping design pattern to create the step interpolators by cloning an uninitialized model and later initializing the copy.

### EulerStepInterpolator

    public EulerStepInterpolator(EulerStepInterpolator interpolator)

  Copy constructor.

  Parameters:
    `interpolator` - interpolator to copy from. The copy is a deep copy: its arrays are separated from the original arrays of the instance

Method Detail

### doCopy

    protected StepInterpolator doCopy()

  Really copy the finalized instance.

  This method is called by `AbstractStepInterpolator.copy()` after the step has been finalized. It must perform a deep copy to have an new instance completely independent for the original instance.

  Specified by:
    `doCopy` in class `AbstractStepInterpolator`
  Returns:
    a copy of the finalized instance

### computeInterpolatedStateAndDerivatives

    protected void computeInterpolatedStateAndDerivatives(double theta,
                                                          double oneMinusThetaH)
                                                   throws DerivativeException

  Compute the state and derivatives at the interpolated time. This is the main processing method that should be implemented by the derived classes to perform the interpolation.

  Specified by:
    `computeInterpolatedStateAndDerivatives` in class `AbstractStepInterpolator`
  Parameters:
    `theta` - normalized interpolation abscissa within the step (theta is zero at the previous time step and one at the current time step)
    `oneMinusThetaH` - time gap between the interpolated time and the current time
  Throws:
    `DerivativeException` - this exception is propagated to the caller if the underlying user function triggers one

Copyright (c) 2003-2013 Apache Software Foundation